/*
 * Copyright (C) 2012 Charlie Curtsinger
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef PASS_UTIL_H
#define PASS_UTIL_H

#include <vector>
#include <set>

#include "llvm/Module.h"
#include "llvm/Function.h"
#include "llvm/InstrTypes.h"
#include "llvm/Instructions.h"
#include "llvm/Constants.h"
#include "llvm/Type.h"
#include "llvm/DerivedTypes.h"
#include "llvm/Intrinsics.h"

#include "llvm/Support/raw_ostream.h"

using namespace std;
using namespace llvm;

GlobalVariable* MakeTable(Module &m, StringRef name, vector<Constant*> values);
GlobalVariable* MakeTable(Module &m, StringRef name, vector<GlobalValue*> values);

Function* MakeConstructor(Module &m, StringRef name);

set<Instruction*> Instructify(Value *v);

void GlobifyFloats(Module &m, Value *v);
Function* getFloatConversion(Module &m, const Type *in, const Type *out, bool is_signed);

size_t objectSize(const Type *t);
Value* computeObjectSize(Module &m, const Type *t);

#endif
