/*
 * Copyright (C) 2012 Charlie Curtsinger
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef stabilizer2_Global_h
#define stabilizer2_Global_h

#include <string.h>
#include <stdint.h>

#include "Metadata.h"
#include "Heaps.h"
//#include "map.h"

#include <map>
#include <pair>

using namespace std;

namespace stabilizer {

	class Global;

	//typedef map<void*, Global*, DH_malloc, DH_free> GlobalMapType;
	typedef map<void*, Global*> GlobalMapType;

	class Global : public Metadata {
	private:
		void *original;
		void *relocated;
		size_t size;

	public:
		Global(void *original, size_t size) {
			this->original = original;
			this->relocated = NULL;
			this->size = size;
		}

		void* getOriginalBase() {
			return this->original;
		}

		void* getRelocatedBase() {
			if(relocated == NULL) {
				relocated = DH_malloc(size);
				memcpy(relocated, original, size);
			}

			return relocated;
		}
	};
}

#endif
