/*
 * Copyright (C) 2012 Charlie Curtsinger
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef stabilizer2_Heaps_h
#define stabilizer2_Heaps_h

#include <stdlib.h>

void* MD_malloc(size_t sz);
void MD_free(void *p);

void* Code_malloc(size_t sz);
void Code_free(void *p);

extern "C" {
	void* DH_malloc(size_t sz);
	void* DH_calloc(size_t n, size_t sz);
	void* DH_realloc(void *ptr, size_t sz);
	void  DH_free(void *p);
	void  DH_flush();
}

#endif
